<?php
/*
  Featured Products Phoenix Cart v2.2.3
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2021: Rainer Schmied - @raiwa

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

  require('includes/application_top.php');

  function tep_set_featured_status($featured_id, $status) {
    if ($status == '1') {
      return tep_db_query(sprintf(<<<'EOSQL'
UPDATE featured
  SET status = '1', expires_date = NULL, date_status_change = NULL
  WHERE featured_id = %s
EOSQL
    , (int)$featured_id));

    } elseif ($status == '0') {
      return tep_db_query(sprintf(<<<'EOSQL'
UPDATE featured
  SET status = '0', date_status_change = now()
  WHERE featured_id = %s
EOSQL
    , (int)$featured_id));

    } else {
      return -1;
    }
  }

  $currencies = new currencies();

  $action = $_GET['action'] ?? '';

  if (tep_not_null($action)) {
    switch ($action) {
      case 'setflag':
        tep_set_featured_status($_GET['id'], $_GET['flag']);
        tep_redirect(tep_href_link('featured.php', '', 'NONSSL'));
        break;
      case 'insert':
        $expires_date = Text::input($_POST['expdate']);
        $product_id = $_POST['products_id'] ?? $_GET['prodID'];
        if (Text::is_empty($expires_date)) {
          $expires_date = '';
        } else {
          $expires_date = substr($expires_date, 0, 4) . substr($expires_date, 5, 2) . substr($expires_date, 8, 2);
        }

        tep_db_query(sprintf(<<<'EOSQL'
INSERT INTO featured (products_id, featured_date_added, expires_date, status)
VALUES ('%s', NOW(), '%s', '1')
EOSQL
    , (int)$product_id, tep_db_input($expires_date)));

        tep_redirect(tep_href_link('featured.php', 'page=' . $_GET['page']));
        break;
      case 'update':
        $expires_date = Text::input($_POST['expdate']);
        if (Text::is_empty($expires_date)) {
          $expires_date = '';
        } else {
          $expires_date = substr($expires_date, 0, 4) . substr($expires_date, 5, 2) . substr($expires_date, 8, 2);
        }

        tep_db_query(sprintf(<<<'EOSQL'
UPDATE featured
  SET featured_last_modified = NOW(), expires_date = %s
  WHERE featured_id = %s
EOSQL
    , tep_db_input($expires_date), (int)$_POST['featured_id']));

       tep_redirect(tep_href_link('featured.php', 'page=' . $_GET['page'] . '&fID=' . $featured_id));
        break;
      case 'deleteconfirm':
        $featured_id = $_GET['fID'];

        tep_db_query(sprintf(<<<'EOSQL'
DELETE
  FROM featured
  WHERE featured_id = %s
EOSQL
    , (int)$featured_id));

        tep_redirect(tep_href_link('featured.php', 'page=' . $_GET['page']));
        break;
    }
  }

require('includes/template_top.php');
?>

  <h1 class="display-4 mb-2"><?= HEADING_TITLE ?></h1>

<?php
  if ( ($action == 'new') || ($action == 'edit') ) {
    $form_action = 'insert';
    if ( ($action == 'edit') && isset($_GET['fID']) ) {
      $form_action = 'update';

      $product_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT p.products_id, pd.products_name, p.products_price, f.expires_date
  FROM products p, products_description pd, featured f
  WHERE p.products_id = pd.products_id
    AND pd.language_id = %s
    AND p.products_id = f.products_id
    AND f.featured_id = %s
  ORDER BY pd.products_name
EOSQL
    , (int)$_SESSION['languages_id'], (int)$_GET['fID']));

      $product = $product_query->fetch_assoc();

      $fInfo = new objectInfo($product);
    } else {
      if ( ($action == 'new') && isset($_GET['prodID']) ) {
      	$product_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT p.products_id, pd.products_name, p.products_price
  FROM products p, products_description pd
  WHERE p.products_id = pd.products_id
    AND pd.language_id = %s
    AND p.products_id = %s
EOSQL
    , (int)$_SESSION['languages_id'], (int)$_GET['prodID']));

      	$product = $product_query->fetch_assoc();
      	$fInfo = new objectInfo($product);
      } else {
      	$fInfo = new objectInfo([]);

		// create an array of featured products, which will be excluded from the pull down menu of products
		// (when creating a new featured product)
      	$featured_array = [];
      	$featured_query = tep_db_query(<<<'EOSQL'
SELECT p.products_id
  FROM products p, featured f
  WHERE f.products_id = p.products_id
EOSQL
    );

      	while ($featured = $featured_query->fetch_assoc()) {
        	$featured_array[] = $featured['products_id'];
        }
      }
    }
?>
    <form name="new_feature" <?= 'action="' . tep_href_link('featured.php', tep_get_all_get_params(['action', 'info', 'fID']) . 'action=' . $form_action, 'NONSSL') . '"' ?> method="post"><?php if ($form_action == 'update') echo tep_draw_hidden_field('featured_id', $_GET['fID']); ?>

      <div class="form-group row">
        <label for="featuredProduct" class="col-form-label col-sm-3 text-left text-sm-right"><?= TEXT_FEATURED_PRODUCT ?></label>
        <div class="col-sm-9"><?php if (isset($fInfo->products_name)) { echo tep_draw_input_field('n', $fInfo->products_name . ' (' . $currencies->format($fInfo->products_price) . ')', 'readonly class="form-control-plaintext"'); } else { echo tep_draw_products_pull_down('products_id', 'id="featuredProduct" class="form-control" required aria-required="true"', $featured_array); } echo tep_draw_hidden_field('products_price', (isset($fInfo->products_price) ? $fInfo->products_price : '')); ?></div>
      </div>

      <div class="form-group row">
        <label for="expdate" class="col-form-label col-sm-3 text-left text-sm-right"><?= TEXT_FEATURED_EXPIRES_DATE ?></label>
        <div class="col-sm-9">
          <?php
          echo tep_draw_input_field('expdate', (isset($fInfo->expires_date) ? substr($fInfo->expires_date, 0, 4) . '-' . substr($fInfo->expires_date, 5, 2) . '-' . substr($fInfo->expires_date, 8, 2) : ''), 'class="form-control" id="expdate"');
          ?>
        </div>
      </div>

      <div class="alert alert-info">
        <?= TEXT_FEATURED_TIP ?>
      </div>

      <?php
        echo '<div class="buttonSet row mr-2 mt-2 mb-2">';
        echo tep_draw_bootstrap_button(IMAGE_SAVE, 'fas fa-save', null, 'primary', null, 'btn-success btn-block btn-lg');
        echo '<div class="col-sm-6">' . tep_draw_bootstrap_button(IMAGE_CANCEL, 'fas fa-angle-left', tep_href_link('featured.php'), null, null, 'btn-light mt-2') . '</div>';
        echo '<div class="col-sm-6">' . tep_draw_bootstrap_button(BUTTON_SEARCH, 'fas fa-search', tep_href_link('select_featured.php'), null, null, 'btn-light btn-block mt-2') . '</div>';
        echo '</div>';
      ?>

    </form>

    <script>$('#expdate').datepicker({ dateFormat: 'yy-mm-dd' });</script>

  <?php
  } else {
  ?>
  <div class="row no-gutters">
    <div class="col">
      <div class="table-responsive">
        <table class="table table-striped table-hover">
          <thead class="thead-dark">
            <tr>
              <th><?= TABLE_HEADING_PRODUCTS ?></th>
              <th class="text-right"><?= TABLE_HEADING_STATUS ?></th>
              <th class="text-right"><?= TABLE_HEADING_ACTION ?></th>
            </tr>
          </thead>
          <tbody>
            <?php
            $featured_query_raw = sprintf(<<<'EOSQL'
SELECT p.products_id, pd.products_name, f.*
  FROM products p, featured f, products_description pd
  WHERE p.products_id = pd.products_id
    AND pd.language_id = %s
    AND p.products_id = f.products_id
  ORDER BY pd.products_name
EOSQL
    , (int)$_SESSION['languages_id']);

            $featured_split = new splitPageResults($_GET['page'], MAX_DISPLAY_SEARCH_RESULTS, $featured_query_raw, $featured_query_numrows);
            $featured_query = tep_db_query($featured_query_raw);
            while ( $featured = $featured_query->fetch_assoc() ) {
              if ( ((!isset($_GET['fID'])) || (isset($_GET['fID']) && $_GET['fID'] == $featured['featured_id'])) && (!isset($fInfo)) ) {

                $products_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT products_image
  FROM products
  WHERE products_id = %s
EOSQL
    , (int)$featured['products_id']));

                $products = tep_db_fetch_array($products_query);
                $fInfo_array = array_merge($featured, $products);
                $fInfo = new objectInfo($fInfo_array);
              }

              if ( (isset($fInfo)) && ($featured['featured_id'] == $fInfo->featured_id) ) {
                echo '<tr onclick="document.location.href=\'' . tep_href_link('featured.php', 'page=' . (int)$_GET['page'] . '&fID=' . (int)$fInfo->featured_id . '&action=edit') . '\'">' . "\n";
              } else {
                echo '<tr onclick="document.location.href=\'' . tep_href_link('featured.php', 'page=' . (int)$_GET['page'] . '&fID=' . (int)$featured['featured_id']) . '\'">' . "\n";
              }
              ?>
                <td><?= $featured['products_name'] ?></td>
                <td class="text-right"><?php if ($featured['status'] == '1') { echo '<i class="fas fa-check-circle text-success"></i> <a href="' . tep_href_link('featured.php', 'action=setflag&flag=0&id=' . (int)$featured['featured_id']) . '"><i class="fas fa-times-circle text-muted"></i></a>'; } else { echo '<a href="' . tep_href_link('featured.php', 'action=setflag&flag=1&id=' . (int)$featured['featured_id']) . '"><i class="fas fa-check-circle text-muted"></i></a> <i class="fas fa-times-circle text-danger"></i>'; } ?></td>
                <td class="text-right"><?php if (isset($fInfo) && is_object($fInfo) && ($featured['featured_id'] == $fInfo->featured_id)) { echo '<i class="fas fa-chevron-circle-right text-info"></i>'; } else { echo '<a href="' . tep_href_link('featured.php', 'page=' . $_GET['page'] . '&sID=' . $featured['featured_id']) . '"><i class="fas fa-info-circle text-muted"></i></a>'; } ?></td>
              </tr>
              <?php
            }
            ?>
          </tbody>
        </table>
      </div>

      <div class="row my-1">
        <div class="col"><?= $featured_split->display_count($featured_query_numrows, MAX_DISPLAY_SEARCH_RESULTS, $_GET['page'], TEXT_DISPLAY_NUMBER_OF_FEATURED) ?></div>
        <div class="col text-right mr-2"><?= $featured_split->display_links($featured_query_numrows, MAX_DISPLAY_SEARCH_RESULTS, MAX_DISPLAY_PAGE_LINKS, $_GET['page']) ?></div>
      </div>

      <?php
      if (empty($action)) {
        echo '<div class="buttonSet row mr-2 mt-2 mb-2">';
          echo '<div class="col-sm-6">' . tep_draw_bootstrap_button(BUTTON_SEARCH, 'fas fa-search', tep_href_link('select_featured.php'), null, null, 'btn-light btn-block btn-lg') . '</div>';
          echo '<div class="col-sm-6">' . tep_draw_bootstrap_button(BUTTON_NEW_FEATURED_PRODUCT, 'fas fa-plus-square', tep_href_link('featured.php', 'page=' . $_GET['page'] . '&action=new'), null, null, 'btn-success btn-block btn-lg text-white') . '</div>';
        echo '</div>';
      }
      ?>

  </div>

<?php
  $heading = [];
  $contents = [];
  switch ($action) {
    case 'delete':
      $heading[] = ['text' => TEXT_INFO_HEADING_DELETE_FEATURED];

      $contents = ['form' => tep_draw_form('featured', 'featured.php', 'page=' . $_GET['page'] . '&fID=' . $fInfo->featured_id . '&action=deleteconfirm')];
      $contents[] = ['text' => TEXT_INFO_DELETE_INTRO];
      $contents[] = ['text' => '<strong>' . $fInfo->products_name . '</strong>'];
      $contents[] = ['align' => 'text-center', 'text' => tep_draw_bootstrap_button(IMAGE_DELETE, 'fas fa-trash', null, 'primary', null, null, 'btn-danger mr-2') . tep_draw_bootstrap_button(IMAGE_CANCEL, 'fas fa-times', tep_href_link('featured.php', 'page=' . $_GET['page'] . '&fID=' . $fInfo->featured_id), null, null, 'btn-light')];
      break;
    default:
      if (isset($fInfo)) {
        $heading[] = ['text' => $fInfo->products_name];

        $contents[] = ['align' => 'text-center', 'text' => tep_draw_bootstrap_button(IMAGE_EDIT, 'fas fa-cogs', tep_href_link('featured.php', 'page=' . $_GET['page'] . '&fID=' . $fInfo->featured_id . '&action=edit'), null, null, 'btn-warning mr-2') . tep_draw_bootstrap_button(IMAGE_DELETE, 'fas fa-trash', tep_href_link('featured.php', 'page=' . $_GET['page'] . '&fID=' . $fInfo->featured_id . '&action=delete'), null, null, null, 'btn-danger')];
        $contents[] = ['text' => TEXT_INFO_DATE_ADDED . ' ' . tep_date_short($fInfo->featured_date_added)];
        $contents[] = ['text' => TEXT_INFO_LAST_MODIFIED . ' ' . tep_date_short($fInfo->featured_last_modified)];
        $contents[] = ['align' => 'text-center', 'text' => '<br>' . tep_info_image($fInfo->products_image, $fInfo->products_name, SMALL_IMAGE_WIDTH, SMALL_IMAGE_HEIGHT)];

        $contents[] = ['text' => TEXT_INFO_EXPIRES_DATE . ' <strong>' . tep_date_short($fInfo->expires_date) . '</strong>'];
        $contents[] = ['text' => TEXT_INFO_STATUS_CHANGE . ' ' . tep_date_short($fInfo->date_status_change)];
      }
      break;
    }
    if ( [] !== $heading && [] !== $contents ) {
      echo '<div class="col-12 col-sm-3">';
        $box = new box;
        echo $box->infoBox($heading, $contents);
      echo '</div>';
    }

    echo '</div>';
  }

  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>