<?php
/*
  Featured Products CE Phoenix v2.2.3
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2021: Rainer Schmied - @raiwa

  Featured Products Phoenix Cart v2.2.3
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2021: Rainer Schmied - @raiwa

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

  class bm_featured extends abstract_block_module {

    const CONFIG_KEY_BASE = 'MODULE_BOXES_FEATURED_';

    public function __construct() {
      parent::__construct(__FILE__);

      $this->description .= '<p>by @raiwa <u><a target="_blank" href="http://www.oscaddons.com">www.oscaddons.com</a></u></p>';
    }

    function execute() {

      $random_query = tep_db_query(sprintf(<<<'EOSQL'
SELECT p.products_id
  FROM products p
  LEFT JOIN featured f
    ON p.products_id = f.products_id
  WHERE p.products_status = '1'
    AND f.status = '1'
  ORDER BY p.products_id DESC
  LIMIT %s
EOSQL
      , MODULE_BOXES_FEATURED_MAX_DISPLAY_FEATURED_PRODUCTS));

      $num_rows = mysqli_num_rows($random_query);
      if (!$num_rows) {
        return;
      }

      tep_db_data_seek($random_query, tep_rand(0, ($num_rows - 1)));
      $random_selection = tep_db_fetch_array($random_query);

      $product = product_by_id::build((int)$random_selection['products_id']);
      $box = [
        'parameters' => ['product_card.php', 'component'],
        'classes' => 'is-product bm-whats-new',
        'title' => sprintf(MODULE_BOXES_FEATURED_BOX_TITLE, tep_href_link('featured_products.php')),
        'attributes' => $product->get('data_attributes'),
      ];

      $tpl_data = [
        'group' => $this->group,
        'file' => 'box.php',
        'type' => 'component',
      ];
      include 'includes/modules/block_template.php';
    }

    protected function get_parameters() {
      return [
        'MODULE_BOXES_FEATURED_STATUS' => [
          'title' => 'Enable Featured Module',
          'value' => 'True',
          'desc' => 'Do you want to add the module to your shop?',
          'set_func' => "tep_cfg_select_option(['True', 'False'], ",
        ],
        'MODULE_BOXES_FEATURED_CONTENT_PLACEMENT' => [
          'title' => 'Content Placement',
          'value' => 'Right Column',
          'desc' => 'Should the module be loaded in the left or right column?',
          'set_func' => "tep_cfg_select_option(['Left Column', 'Right Column'], ",
        ],
        'MODULE_BOXES_FEATURED_MAX_DISPLAY_FEATURED_PRODUCTS' => [
          'title' => 'Max Display',
          'value' => '6',
          'desc' => 'Maximum Featured Products to be display.',
        ],
        'MODULE_BOXES_FEATURED_SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '0',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
      ];
    }

  }
